/************************************************************************/
/*                                                                      */
/*      Zoom Page  -  Firefox Extension  -  Options                     */
/*                                                                      */
/*      Javascript for Options dialog                                   */
/*                                                                      */
/*      Copyright (C) 2009-2012  by  DW-dev                             */
/*                                                                      */
/*      Last Edit  -  06 Oct 2012                                       */
/*                                                                      */
/************************************************************************/

var zoomPageOptions =
{
    appInfo: Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo),
    versionComparator: Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator),
    ffVersion: "",
    
    prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.zoompage."),
    
    otherPrefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),
    
    contentPrefs: Components.classes["@mozilla.org/content-pref/service;1"].getService(Components.interfaces.nsIContentPrefService),
    
    zoomLevels: new Array("30-50-67-80-90-100-110-120-133-150-170-200-240-300",
                          "30-50-75-100-125-150-200-300-400",
                          "30-50-75-90-100-110-125-150-200-300-400",
                          "30-50-67-80-90-100-110-120-133-150-170-200-240-300-400",
                          "25-50-75-100-125-150-200-300-400-500",
                          "25-50-75-90-100-110-125-150-200-300-400-500",
                          "25-50-67-80-90-100-110-120-133-150-170-200-240-300-400-500"),
    
    initPrefs: function()
    {
        var i,menulist,textbox,tooltip;
        var checkbox,checkstate;
        var levelArray = new Array();
        
        /* Determine Firefox version */
        
        if (zoomPageOptions.versionComparator.compare(zoomPageOptions.appInfo.version,"14.0b1") >= 0) zoomPageOptions.ffVersion = "14.0";
        else if (zoomPageOptions.versionComparator.compare(zoomPageOptions.appInfo.version,"4.0b1") >= 0) zoomPageOptions.ffVersion = "4.0";
        else zoomPageOptions.ffVersion = "3.6";
        
        /* Button Style */
        
        menulist = document.getElementById("zoompage-buttonstyle");
        if (zoomPageOptions.ffVersion == +"3.6") menulist.setAttribute("disabled","true");
        try
        {
            if (zoomPageOptions.ffVersion == +"3.6") menulist.value = "c";
            else if (zoomPageOptions.ffVersion >= +"4.0") menulist.value = zoomPageOptions.prefs.getCharPref("buttonstyle");
        }
        catch(e)
        {
            if (zoomPageOptions.ffVersion == +"3.6") menulist.value = "c";
            else if (zoomPageOptions.ffVersion >= +"4.0") menulist.value = "n";
        }
        
        /* Custom Zoom Levels */
        
        textbox = document.getElementById("zoompage-customlevels");
        try
        {
            textbox.value = zoomPageOptions.prefs.getCharPref("customlevels");
        }
        catch(e)
        {
            textbox.value = "100";
        }
        
        /* Current Zoom Levels */
        
        zoomPageOptions.zoomLevels[7] = zoomPageOptions.prefs.getCharPref("customlevels");
        
        menulist = document.getElementById("zoompage-zoomlevels");
        menulist.appendItem(document.getElementById("zoompage-firefoxmarker").value + "  " + zoomPageOptions.zoomLevels[0]);
        menulist.appendItem("1:  " + zoomPageOptions.zoomLevels[1]);
        menulist.appendItem("2:  " + zoomPageOptions.zoomLevels[2]);
        menulist.appendItem("3:  " + zoomPageOptions.zoomLevels[3]);
        menulist.appendItem("4:  " + zoomPageOptions.zoomLevels[4]);
        menulist.appendItem("5:  " + zoomPageOptions.zoomLevels[5]);
        menulist.appendItem("6:  " + zoomPageOptions.zoomLevels[6]);
        menulist.appendItem(document.getElementById("zoompage-custommarker").value + "  " + zoomPageOptions.zoomLevels[7]);
        try
        {
            menulist.selectedIndex = zoomPageOptions.prefs.getIntPref("zoomlevels");
        }
        catch(e)
        {
            menulist.selectedIndex = 0;
        }
        
        tooltip = document.getElementById("zoompage-zoomlevels-tooltip-label");
        tooltip.setAttribute("value",menulist.getItemAtIndex(menulist.selectedIndex).label.substr(4));
        
        /* Default Zoom Level */
        
        levelArray = zoomPageOptions.zoomLevels[document.getElementById("zoompage-zoomlevels").selectedIndex].split("-");
        
        menulist = document.getElementById("zoompage-defaultzoom");
        for (i = 0; i < levelArray.length; i++) menulist.appendItem(levelArray[i],levelArray[i]);
        try
        {
            menulist.value = zoomPageOptions.prefs.getIntPref("defaultzoom");
        }
        catch(e)
        {
            menulist.value = 100;
        }
        
        /* Site Specific Zoom */
        
        checkbox = document.getElementById("zoompage-sitespecific");
        try
        {
            checkstate = zoomPageOptions.otherPrefs.getBoolPref("browser.zoom.siteSpecific");
            checkbox.checked = checkstate;
        }
        catch(e)
        {
            checkbox.checked = false;
        }
        
        /* Left-Click Reset */
        
        checkbox = document.getElementById("zoompage-leftclick");
        try
        {
            checkstate = zoomPageOptions.prefs.getBoolPref("leftclick");
            checkbox.checked = checkstate;
        }
        catch(e)
        {
            checkbox.checked = true;
        }
        
        zoomPageOptions.onChangeButtonStyle();
        
        /* Italic Percentage */
        
        checkbox = document.getElementById("zoompage-italicpercent");
        try
        {
            checkstate = zoomPageOptions.prefs.getBoolPref("italicpercent");
            checkbox.checked = checkstate;
        }
        catch(e)
        {
            checkbox.checked = true;
        }
        
        /* Red Percentage */
        
        checkbox = document.getElementById("zoompage-redpercent");
        try
        {
            checkstate = zoomPageOptions.prefs.getBoolPref("redpercent");
            checkbox.checked = checkstate;
        }
        catch(e)
        {
            checkbox.checked = true;
        }
        
        /* Prefix Percentage */
        
        checkbox = document.getElementById("zoompage-prefixpercent");
        try
        {
            checkstate = zoomPageOptions.prefs.getBoolPref("prefixpercent");
            checkbox.checked = checkstate;
        }
        catch(e)
        {
            checkbox.checked = true;
        }
    },
    
    onChangeButtonStyle: function()
    {
        var menulist,checkbox;
        
        menulist = document.getElementById("zoompage-buttonstyle");
        checkbox = document.getElementById("zoompage-leftclick");
        if (menulist.value == "m") checkbox.setAttribute("disabled","true");
        else checkbox.removeAttribute("disabled");
    },
    
    onChangeZoomLevels: function()
    {
        var i,menulist,defaultzoom,tooltip;
        var levelArray = new Array();
        
        levelArray = zoomPageOptions.zoomLevels[document.getElementById("zoompage-zoomlevels").selectedIndex].split("-");
        
        menulist = document.getElementById("zoompage-defaultzoom");
        defaultzoom = menulist.value;
        menulist.removeAllItems();
        for (i = 0; i < levelArray.length; i++) menulist.appendItem(levelArray[i],levelArray[i]);
        for (i = 0; i < levelArray.length; i++) if (levelArray[i] == defaultzoom) break;
        if (i < levelArray.length) menulist.value = levelArray[i]; else menulist.value = 100;
        
        menulist = document.getElementById("zoompage-zoomlevels");
        tooltip = document.getElementById("zoompage-zoomlevels-tooltip-label");
        tooltip.setAttribute("value",menulist.getItemAtIndex(menulist.selectedIndex).label.substr(4));
    },
    
    onCommandCustomValidate: function()
    {
        var i,textbox,textstr,levels,index,menulist;
        var levelArray = new Array();
        
        textbox = document.getElementById("zoompage-customlevels");
        
        textstr = textbox.value;
        
        for (i = 0; i < textstr.length; i++)
        {
            if (textstr.charAt(i) >= "0" && textstr.charAt(i) <= "9") continue;
            if (textstr.charAt(i) == "-") continue;
            textstr = textstr.substr(0,i) + textstr.substr(i+1);
            i--;
        }
        
        levelArray = textstr.split("-");
        levelArray.push("100");
        levelArray.sort(function(a,b){ return a-b });
        
        for (i = 0; i < levelArray.length; i++)
        {
            if (Number(levelArray[i]) < 1 || Number(levelArray[i]) > 10000) { levelArray.splice(i,1); i--; }
            if (i > 0 && levelArray[i] == levelArray[i-1]) { levelArray.splice(i,1); i--; }
        }
        
        levels = "" + levelArray[0];
        for (i = 1; i < levelArray.length; i++) levels = levels + "-" + levelArray[i];
        
        textbox.value = levels;
        
        zoomPageOptions.zoomLevels[7] = levels;
        
        menulist = document.getElementById("zoompage-zoomlevels");
        index = menulist.selectedIndex;
        
        menulist.removeItemAt(7);
        menulist.appendItem(document.getElementById("zoompage-custommarker").value + "  " + zoomPageOptions.zoomLevels[7]);
        
        menulist.selectedIndex = index;
        
        if (index == 7) zoomPageOptions.onChangeZoomLevels();
    },
    
    savePrefs: function()
    {
        var i,levels;
        var levelArray = new Array();
        
        zoomPageOptions.onCommandCustomValidate();
        
        /* Button Style */
        
        zoomPageOptions.prefs.setCharPref("buttonstyle",document.getElementById("zoompage-buttonstyle").value);
        
        /* Current Zoom Levels */
        
        zoomPageOptions.prefs.setIntPref("zoomlevels",document.getElementById("zoompage-zoomlevels").selectedIndex);
        
        levelArray = zoomPageOptions.zoomLevels[document.getElementById("zoompage-zoomlevels").selectedIndex].split("-");
        levels = "" + levelArray[0]/100;
        for (i = 1; i < levelArray.length; i++) levels = levels + "," + levelArray[i]/100;
        
        zoomPageOptions.otherPrefs.setIntPref("zoom.minPercent",levelArray[0]);
        zoomPageOptions.otherPrefs.setIntPref("zoom.maxPercent",levelArray[levelArray.length-1]);
        zoomPageOptions.otherPrefs.setCharPref("toolkit.zoomManager.zoomValues",levels);
        
        /* Custom Zoom Levels */
        
        zoomPageOptions.prefs.setCharPref("customlevels",document.getElementById("zoompage-customlevels").value);
        
        /* Default Zoom Level */
        
        zoomPageOptions.prefs.setIntPref("defaultzoom",document.getElementById("zoompage-defaultzoom").value);
        
        zoomPageOptions.contentPrefs.setPref(null,"browser.content.full-zoom",document.getElementById("zoompage-defaultzoom").value/100);
        
        /* Site Specific Zoom */
        
        zoomPageOptions.otherPrefs.setBoolPref("browser.zoom.siteSpecific",document.getElementById("zoompage-sitespecific").checked);
        
        /* Left-Click Reset */
        
        zoomPageOptions.prefs.setBoolPref("leftclick",document.getElementById("zoompage-leftclick").checked);
        
        /* Italic Percent */
        
        zoomPageOptions.prefs.setBoolPref("italicpercent",document.getElementById("zoompage-italicpercent").checked);
        
        /* Red Percent */
        
        zoomPageOptions.prefs.setBoolPref("redpercent",document.getElementById("zoompage-redpercent").checked);
        
        /* Prefix Percentage */
        
        zoomPageOptions.prefs.setBoolPref("prefixpercent",document.getElementById("zoompage-prefixpercent").checked);
    }
};
